Attribute VB_Name = "modMain"
Option Explicit

Private Declare Function GetDesktopWindow Lib "user32" () As Long

Private Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long

Private Declare Function GetWindow Lib "user32" (ByVal hWnd As Long, ByVal wCmd As Long) As Long

Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long

Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hWnd As Long) As Long

Private Declare Function IsWindowVisible Lib "user32" (ByVal hWnd As Long) As Long

' Window field offsets for GetWindowLong() and GetWindowWord()
Private Const GWL_OWNER = 4
Private Const GWL_WNDPROC = (-4)
Private Const GWL_HINSTANCE = (-6)
Private Const GWL_HWNDPARENT = (-8)
Private Const GWL_STYLE = (-16)
Private Const GWL_EXSTYLE = (-20)
Private Const GWL_USERDATA = (-21)
Private Const GWL_ID = (-12)

' GetWindow() Constants
Private Const GW_HWNDFIRST = 0
Private Const GW_HWNDLAST = 1
Private Const GW_HWNDNEXT = 2
Private Const GW_HWNDPREV = 3
Private Const GW_OWNER = 4
Private Const GW_CHILD = 5
Private Const GW_MAX = 5

Public gnFile As Integer


Public Function EnumWindowsProc(ByVal vlhWnd As Long, ByVal vlUserDefined As Long) As Boolean

    Dim nCaptionLength As Integer
    Dim nImage As Integer
    
    Dim sCaption As String
    
        
    nImage = 0
        
    '
    '   Is it invisible?
    '
    If (0 <> IsWindowVisible(vlhWnd)) Then
        nImage = nImage Or 1
    End If
    
    '
    '   Does the Window have a Parent?
    '
    If (0 <> GetWindowLong(vlhWnd, GWL_HWNDPARENT)) Then
        nImage = nImage Or 2
        '
        '   Is the Parent the desktop?
        '
        If (GetDesktopWindow() = GetWindowLong(vlhWnd, GWL_HWNDPARENT)) Then
            nImage = nImage Or 8
        End If
    End If
    
    '
    '   Is it a top window (no owner)?
    '
    If (0 = GetWindowLong(vlhWnd, GWL_OWNER)) Then
        nImage = nImage Or 4
    Else
        '
        '   Is the Owner the desktop?
        '
        If (GetDesktopWindow() = GetWindowLong(vlhWnd, GWL_OWNER)) Then
            nImage = nImage Or 8
        End If
    End If
    
    '
    '   Does it have a caption
    '
    sCaption = String$(GetWindowTextLength(vlhWnd) + 1, Chr$(0))
    If (1 < Len(sCaption)) Then
        '
        '   Can we get the caption?
        '
        nCaptionLength = GetWindowText(vlhWnd, sCaption, Len(sCaption))
        If (0 < nCaptionLength) Then
            '
            '   Yes -- add it to our list
            '
            frmMain.lbSort.AddItem Left$(sCaption, nCaptionLength) & Format$(nImage, "0000")
            frmMain.lbSort.ItemData(frmMain.lbSort.NewIndex) = vlhWnd
        End If
    End If
    
    If (0 <> gnFile) Then
        Print #gnFile, 0 & ",""" & sCaption & """," & vlhWnd & "," & GetWindowLong(vlhWnd, GWL_OWNER) & "," & GetWindowLong(vlhWnd, GWL_HWNDPARENT) & "," & GetParent(vlhWnd)
    End If
    
    '
    '   Return true
    '
    EnumWindowsProc = True

End Function



